<?php
namespace ptntickernewsticker_nacespace;

define( "PTNTICKER_ASFSK_ASSETS_ADMIN_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/admin" );

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class Classptntickernewsticker {

	private static $_instance = null;

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function ptnticker_admin_editor_scripts() {
		add_filter( 'script_loader_tag', [ $this, 'ptnticker_admin_editor_scripts_as_a_module' ], 10, 2 );
	}

	public function ptnticker_admin_editor_scripts_as_a_module( $tag, $handle ) {
		if ( 'ptnticker_newsticker_editor' === $handle ) {
			$tag = str_replace( '<script', '<script type="module"', $tag );
		}

		return $tag;
	}

	private function include_widgets_files() {
		require_once( __DIR__ . '/widgets/ptnticker-newsticker-widgets.php' );
	}

	public function ptnticker_register_widgets() {
		// Its is now safe to include Widgets files
		$this->include_widgets_files();

		// Register WidgetsF
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\ptnticker_newsticker_widgets());
	}

	// Register Category
	function ptnticker_new_add_elementor_widget_categories( $elements_manager ) {

		$elements_manager->add_category(
			'ptnticker-newsticker-category',
			[
				'title' => esc_html__( 'Post Type News Ticker', 'post-type-news-ticker' ),
				'icon' => 'eicon-person',
			]
		);
	}

	public function ptnticker_all_assets_for_the_public(){
		$ptnticker_cnd_link = 'https://bwd-elementor-addons-pro.netlify.app/post-type-news-ticker/';
		wp_enqueue_script( 'ptnticker_newsticker_jquery', $ptnticker_cnd_link. 'owl.carousel.min.js', array('jquery'), '2.1', true );
		wp_enqueue_script( 'ptnticker_newsticker_main', $ptnticker_cnd_link. 'main.js', array('jquery'), '2.1', true );
		$all_css_js_file = array(
            'ptnticker_newsticker_plugin_animate' => array('ptnticker_path_define'=>$ptnticker_cnd_link.'animate.min.css'),
            'ptnticker_newsticker_plugin_owl_carousel' => array('ptnticker_path_define'=>$ptnticker_cnd_link.'owl.carousel.min.css'),
            'ptnticker_newsticker_plugin_main' => array('ptnticker_path_define'=>$ptnticker_cnd_link.'style.css'),

        );
        foreach($all_css_js_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['ptnticker_path_define'], null, '2.1', 'all');
        }
	}


	public function ptnticker_all_assets_for_elementor_editor_admin(){
		$all_css_js_file = array(
            'ptnticker_newsticker_admin_icon_css' => array('ptnticker_path_admin_define'=>PTNTICKER_ASFSK_ASSETS_ADMIN_DIR_FILE . '/icon.css'),
        );
        foreach($all_css_js_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['ptnticker_path_admin_define'], null, '2.1', 'all');
        }
	}
	
	public function __construct() {

		// For public assets
		add_action('wp_enqueue_scripts', [$this, 'ptnticker_all_assets_for_the_public']);

		// For Elementor Editor
		add_action('elementor/editor/before_enqueue_scripts', [$this, 'ptnticker_all_assets_for_elementor_editor_admin']);
		
		// Register Category
		add_action( 'elementor/elements/categories_registered', [ $this, 'ptnticker_new_add_elementor_widget_categories' ] );

		// Register widgets
		add_action( 'elementor/widgets/widgets_registered', [ $this, 'ptnticker_register_widgets' ] );

		// Register editor scripts
		add_action( 'elementor/editor/after_enqueue_scripts', [ $this, 'ptnticker_admin_editor_scripts' ] );
	}
}

// Instantiate Plugin Class
Classptntickernewsticker::instance();